=== debian/changelog ===
julia (1.0.1-0ubuntu2) cosmic; urgency=medium

  [ Mo Zhou ]
  * Extend JULIA_CPU_TARGET to include optimized targets as well,
    apart from the generic target. (Closes: #910784)

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 15 Oct 2018 07:57:30 +0000

julia (1.0.1-0ubuntu1) cosmic; urgency=medium

  [ Graham Inggs ]
  * Sync with 1.0.1-1 from Debian binNEW
  * Skip DNS tests which fail on Ubuntu autopkgtest infrastructure  

  [ Mo Zhou ]
  * New upstream stable release 1.0.1 (Sept 2018)
  * Remove hundreds of patches picked from WIP Julia 1.0.1 release.
  * Elaborate on why debug info should not be stripped from sys.so in rules.
  * Drop deps:openspecfun which is not used anymore since 0.7 release.
  * Add CUSTOM_NATIVE variable in rules for custom builds.
  * Drop test related patches, because they are not needed anymore:
    - Drop test-add-envvar-for-skipping-network-tests.patch .
    - Drop test-moredetail.patch, test-skip-ppc64el-spec.patch
    - Drop test-remove-powermod.patch, test-aggressive-gc.patch .

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 02 Oct 2018 08:35:36 +0000

julia (1.0.0-3) unstable; urgency=medium

  * Handle floating point precision issue during test. (test-precision.patch)
  * Patch runtests.jl to let it print more detail. (test-moredetail.patch)
  * Make Documenter.jl quiet. (pre-apply, doc-silent.patch)
  * Autopkgtest: Skip network related tests for Ubuntu.
  * Link libjulia.so.X against netlib LAPACK (libblas.so.3/liblapack.so.3)
    in order to take advantage from alternatives system. (Closes: #905826)
  * Shared object libjulia.so.X Depends on high performance BLAS/LAPACK
    implementations when available, i.e. OpenBLAS | Atlas | Intel-MKL.
  * Add 167 patches from work-in-progress Julia 1.0.1 release.
  * Autopkgtest: Execute runtests.jl instead of calling Base.runtests()
  * README.Debian: Julia's BLAS/LAPACK backend is switchable henceforth.
  * Also remove the "net_on" guard in test/runtests.jl.
    (update, test-add-envvar-for-skipping-network-tests.patch)
  * Downgrade GCC version to 7 for armhf in order to circumvent FTBFS.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 23 Sep 2018 03:11:52 +0000

julia (1.0.0-2) unstable; urgency=medium

  * Run test on all architectures instead of only amd64 and i386,
    but allow non-x86 tests to fail. (Closes: #906754)
  * Binary package julia Suggests vim-julia. (Closes: #907050)
  * Enable the build on s390x
    - Disable libunwind on s390x (unsatisfiable dependency).
    * shlibdeps.mk: don't link against libunwind on s390x architecture.
    * Fix logic error in base/Makefile. (+ make-unwind-logic-error.patch)
  * Skip some tests unconditionally or conditionally according to Sys.ARCH
    * Skip "powermod" related tests on non-x86 architecture.
    * Skip several tests specifically on i386. (+ test-skip-i386-spec.patch)
    * Skip several tests on ppc64el. (+ test-skip-ppc64el-spec.patch)
    * Add patch test-add-envvar-for-skipping-network-tests.patch.
      + rules: Export DEBIAN_FORCE_NONET to skip network tests during build.
  * Add patch test-aggressive-gc.patch: make garbage collection aggressive.
  * Re-arrange patches and refresh them.
  * Disable thumb instruction set for armhf by adding -marm to cflags.
  * Bump Standards-Version to 4.2.1 (no change).
  * rules: Don't install extra license files.
  * Override false-positive lintian error: wrong-path-for-interpreter.
  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 14 Sep 2018 11:09:12 +0000

julia (1.0.0-1) experimental; urgency=medium

  * New upstream version 1.0.0
  * Bump SOVERSION from 0.7.0 to 1.0.0, update debian directory accordingly.
  * Package libjulia1.0 Breaks and Replaces libjulia0.7 .
  * Refresh symbols list for libjulia.so.1.0 .
  * Update the embedded Documenter:
    + Documenter.jl to v0.19.4
    + Compat.jl to v1.0.1 .
    + DocStringExtensions.jl to v0.4.6 .
    * Update debian/source/include-binaries accordingly.
    * Update patch privacy-breach.patch and pre-apply the patch.
  * Add patch doc-unicode-data-path.patch and update deb-make-doc.patch
    to avoid UnicodeData.txt File-Not-Found during documentation build.
  * Refresh debian/copyright.
  * Also build the PDF documentation apart from the HTML doc.
    + Add latex related Build-Depends-Indep packages for building PDF doc.
    + Override dh_auto_build-indep to build both HTML and PDF document.
    + Install the generated PDF doc doc/_build/pdf/en/TheJuliaLanguage.pdf
    + Register the PDF documentation in doc-base.
  * Remove source/local-options , not useful anymore.
  * Update appstream.patch from upstream pull request #28020.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 16 Aug 2018 07:48:17 +0000

julia (0.7.0-2) unstable; urgency=medium

  [ Peter Colberg ]
  * Drop Build-Depends on libfftw3-dev, Bindings to the FFTW library
    have been removed from Base. (Closes: #905849)

  [ Mo Zhou ]
  * Replace Sys.CPU_CORES with Sys.CPU_THREADS in test script.
  * Add patch test-skip-sigint.patch to temporarily avoid a random
    test failure in test/stress.jl, which sometimes fail to catch SIGINT.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 12 Aug 2018 01:00:36 +0000

julia (0.7.0-1) unstable; urgency=medium

  * New upstream version 0.7.0
  * Update embedded libuv tarball to ed3700c849289ed01fe04273a7bf865340b2bd7e.
  * Refresh all the patches.
  * Move privacy-breach.patch to quilt directory, and pre-apply the patch.
  * Require libgit2-dev (>= 0.27.0~) as B-D.
  * Bump Standards-Version to 4.2.0 (no change).
  * Three new symbols for libjulia0.7 0.7.0 .
  * Only traverse within debian directory when fixing shebang. (Avoid FTBFSx2)
  * README.Debian: Add brief instructions for rebuilding Julia against MKL.
  * Update file matching expressions in copyright.
  * Require llvm-6.0-dev (>= 1:6.0.1-3) in the B-D field.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 09 Aug 2018 16:43:05 +0000

julia (0.7.0~beta2-1) experimental; urgency=medium


